This read me is outdated

The idea is to overload only
- route_info (To receive specific parameters from specific routers, usually the routes will have the parameters on them, so route_info actually should not be inherited, but either way is recomended)
- route_info_parser (To navigate to the received routes and get the received parameters)
- router_provider (To decide the app state, it is recomended to decide what to do when user is authenticated / non authenticated from the provider, and then the routes in each state should push/pop to each other freely, accepting links from outside etc...)

To create routes you inherit from ComposableRoute and specify the route rules there, the router provider will handle all the work

To navigate just use the router provider push, pop, etc..., its recommended to instantiate it as a Provider, or just instantiate it in the global namespace

You should not need to change
- router_delegate (This is already doing its job of delegating changes to and from the os to the router provider)
- route (The route should be just a path, a screen and a can enter)

You can still inherit and do anything to these classes, its just not the way i recomend going about it

Having each route handle its permissions is much cleaner and easier to maintain, grouping the whole app autorization logic into a single place gets hard to understand

## How to use
### Setting up the classes
- Inherit the ComposableRouterProvider
- - You must override onInitialize which should return the initial route (*note* The OS will make a request to navigate as soon as the app initializes, so this initial route may not be the one you will see, it will depend if the Route the OS requested to enter can be entered and your RouteInfoParser result, usually the OS will just request "/", but if its on the WEB for instance the user can type anything)
- Inherit the ComposableRouteInfoParser
- - You must override parseRouteInformation which should return the Route to navigate to based on the information received (*note* This is basically the URL, you can use to navigate your app right to where the user wants to be right on the startup)

### Setting up the router
- Instantiate your ComposableRouterProvider derived class
- - *Recommended* Use the Provider package and instantiate a provider of your class before instantiating the router
`ListenableProvider<AppRouterProvider>(create: (context) => AppRouterProvider())`
- - You can ofcourse just initialize it globally in a separated file preferably so you can call it anywhere without including anything non needed
`main() { what ever... } AppRouterProvider appRouter = AppRouterProvider();`
- After that you need to Instantiate WidgetsApp with the router() named constructor
- - In the routerDelegate Instantiate ComposableRouterDelegate passing your provider instance as a parameter as well as the current context (*note* pass in the WidgetsApp context, because the provider will use this context to evaluate things, to do that just make sure the WidgetsApp is the first widget in your widget.build function)
- - In the routeInformationParser instantiate your ComposableRouterInfoParser derived class

### Navigating
- You can call the Provider push/pop... methods to navigate arround pages
- You can override the Route canEnter method to decide if the user can enter that route at that point (*note* this method is called by the provider before a route is pushed or popped into)
- You can set the provider to listen to all navigation related delegates in your application and the provider handle 100% of all transitions
- You can redirect to a route with the url or intent, the router will check if it can be entered before redirecting the user there 
- You can set the allowedRoutes member from the Provider to restringe the user from entering non allowed routes at that stage in the application


### Best practices
My idea on using the router is to use the Provider to handle App related states, like if the user is authenticated or not and deciding the allowed routes for when the user is in certain state.

And then in the pages itself we can have the buttons redirecting to wherever they want to be redirected to, and if it tries to enter a page that is not allowed it will just not go.

Its best to use the Route.canEnter method alongside the Provider allowed routes, because you can then better manage complex logic for each route

### Example
Inside Provider callback for Authentication Provider changes
> User Authenticated
    ? setAllowedRoutes(WelcomeRoute, SignInRoute, SignUpRoute)
    : setAllowedRoutes(DashboardRoute, ProjectRoute)


Inside ProjectRoute canEnter function
> return CheckIfUserHasAccessToProject(ProjectId);

Now if you redirect to ProjectRoute with the authenticated user id the route will check if the user has access to the project before rejecting or allowing the user enter the route, if the user is not authenticated it will fail even before calling the canEnter, because it will not be in the allowed routes list

To pass parameters from the URL or Intent to the Route in your RouteInformationParser you can use routeInformation.location to parse the route and get the project id for instance, and then the Route can pass this information to the Screen
>- OS request a route
>- Route Info Parser parses the request into a ComposableRoute derived class
>- ComposableRoute derived class constructs the Screen passing any parsed information it needs
