import 'package:composable_router/composable_router_delegate.dart';
import 'package:example/app_route_info_parser.dart';
import 'package:example/app_router_controller.dart';
import 'package:example/app_router_provider.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return ListenableProvider<AppRouterProvider>(
      create: (context) => AppRouterProvider(historyLimit: 10),
      builder: (context, child) {
        return Provider<AppRouterController>(
          create: (context) => AppRouterController(context),
          lazy: false,
          child: MaterialApp.router(
            // Setup the app router
            routerDelegate: ComposableRouterDelegate(
              context.read<AppRouterProvider>(),
              context: context,
            ),
            routeInformationParser: AppRouteInfoParser(
              context.read<AppRouterProvider>(),
              context: context,
            ),
          ),
        );
      },
    );
  }
}
