import 'package:example/app_router_provider.dart';
import 'package:example/routes/parameter_router.dart';
import 'package:flutter/material.dart';
import 'package:composable_router/composable_route.dart';
import 'package:provider/provider.dart';

class HomeRoute extends ComposableRoute {
  @override
  String path() => "/Home";

  TextEditingController _textEditingController = TextEditingController();

  @override
  Page screen(BuildContext context) => MaterialPage(
        // This is meant to be a HomeScreenWidget or HomeRouteWidget or anything,
        // but in another file
        child: Scaffold(
          body: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment: CrossAxisAlignment.center,
            children: [
              const Text("Home route"),
              TextFormField(
                controller: _textEditingController,
              ),
              ElevatedButton(
                onPressed: () {
                  // Get the app router provider
                  final appRouter = context.read<AppRouterProvider>();
        
                  // Push the new route
                  // This is one of the many ways you can control the app flow
                  // with composable router, you can have a main controller
                  // deciding the allowed router and maybe the current route,
                  // and have screens also being able to dictate where they can
                  // take the user
                  appRouter.push(
                    ParameterRoute(dummyParameter: _textEditingController.text),
                  );
                },
                child: Text("Navigate to Parameter Route"),
              ),
            ],
          ),
        ),
      );
}
