import 'package:composable_router/composable_route.dart';
import 'package:flutter/material.dart';

class ParameterRoute extends ComposableRoute {
  ParameterRoute({this.dummyParameter});

  /// A dummy test parameter
  String? dummyParameter;

  @override
  String path() =>
      "/Parameter${dummyParameter != null ? "/$dummyParameter" : ""}";

  @override
  Page screen(BuildContext context) => MaterialPage(
        child: Scaffold(
          body: Center(
            child: Text(dummyParameter ?? "Parameter not specified"),
          ),
        ),
      );

  @override
  bool canEnter(BuildContext context) => dummyParameter != null;
}
