import 'package:flutter/widgets.dart';

/// The base class of a composable router route
abstract class ComposableRoute {
  /// Returns the route path, ex: HomeRoute.path() => "/Home"
  String path();

  /// Builds the route screen
  Page screen(BuildContext context);

  /// Decides if the router can take this route
  bool canEnter(BuildContext context) => true;

  /// RouterRoute objects are not unique
  @override
  int get hashCode => runtimeType.hashCode;

  /// Equals hashCode
  @override
  bool operator ==(Object other) {
    if (other.runtimeType != runtimeType) return false;
    return other is ComposableRoute && other.hashCode == hashCode;
  }
}
