import 'package:composable_router/library.dart';
import 'package:flutter/widgets.dart';

/// Parses navigation requests received from the OS into ComposableRouteInfo
abstract class ComposableRouteInfoParser
    extends RouteInformationParser<ComposableRoute> {
  ComposableRouteInfoParser(
    this._provider, {
    required BuildContext context,
  }) : _context = context;

  /// Responsible for managing our states
  final ComposableRouterProvider _provider;
  ComposableRouterProvider get provider => _provider;

  /// Our build context
  final BuildContext _context;
  BuildContext get context => _context;

  @override
  RouteInformation? restoreRouteInformation(ComposableRoute configuration) {
    return RouteInformation(location: configuration.path());
  }
}
